(function(App, $){
		
	var headlines = {
		query : undefined
	};

	$.extend(App.modules, { headlines : headlines });
	
	headlines.init = function(load) {
		var self = this,
			pageId = 'headlines-page-' + App.currentSport;
		
		if (load) {
			App.showMainPage({
				pageId : pageId, 
				module : 'headlines',
				tmplData : {
					videoTab : App.conf.client.sports[App.currentSport].params && App.conf.client.sports[App.currentSport].params.videoTab,
                    gaTitle : 'Headlines',
                    refreshable : true,
					headerSportFav : App.currentSport !== 0,
					isFavourite : _.indexOf(App.services.favSports.getFavSports(), App.currentSport) !== -1
				}
			});
		}
		
		if (! self.initialized) {
		
			//load article
			$(document).on('tap', '.article-load', function(){
				var url = App.normalizeURL($(this).data('url')),
					pageId = ($(this).data('targetPageId') ? $(this).data('targetPageId') : App.generatePageId('article')),
					tmplData = {
						backButtonLabel : App.currentModule !== 'headlines' ? 'Scores' : 'News',
                        gaTitle : 'Article'
					};
						
				$(this).data('targetPageId', pageId);
						
				App.initSubPage({
					pageId : pageId,
					pageType : 'article',
					url : url,
					tmplData : tmplData,
					parser : $.proxy(self.parseArticle, self)
				});

				return false;
			});

			// headlines tab should always be highlighted
			$(document).on('tap', '.headlines-subtabs', function() {
				$(this).find('.main-trigger:first').addClass(App.conf.classes.activeBtn);
			});
			
			//links in the article opens in child browser
			$(document).on('tap', '.headlines-page .mobile-article a', function(e){
				App.openExternalLink($(this).attr('href'));
				return false;
			});
			
			$(document).on('tap', '.headlines-page .twitter-li', function() {
				$(this).removeClass(App.conf.classes.activeBtn + ' ui-btn-focus');
			});
			
			// video sub-page
			$(document).on('tap', '.headlines-video-link', function() {
				var link = $(this),
					pageId = App.generatePageId('video'),
					rendered = $(App.templates['sub-page']($.extend({}, App.defaultTemplateData, {
						pageId : pageId,
						page : App.templates['video-page'](link.data()),
						title : App.getCurrentSportTitle(),
						pageClass : 'video-page',
						footerActiveButton : App.currentModule,
                        backButtonLabel : 'News'
					}))),
					page;
				
				page = App.createPage(rendered);
				App.changePage(pageId);

				// remove page once hidden - but not in case dialog openings
				page.on('pagehide', function(){
					if ($.mobile.activePage.data('role') !== 'dialog') {
						console.log('video page removed');
						page.remove();
					}
				});
				
				return false;
			});
			
			self.initialized = true;
		}
	};
	
	headlines.parseArticle = function(data){
		data = $('<div />').append(data);
		
		data.find('a').each(function(){
			$(this)
				.attr('href', App.normalizeURL($(this).attr('href')))
                .addClass('external-link');
		});
		App.adjustImagePaths(data.find('img'));
		
		return data.html();
	};

})(App, jQuery);