App.services.settings = {
    init : function() {
        this.settings = _.extend({
            useLocalTimeZone : false,
            hideScores : false,
            articleTextSize : '2'
        }, JSON.parse(window.localStorage.getItem('settings')));
    },

    set : function(name, value) {
        this.settings[name] = value;
        $.publish('settings/change', [name, value]);
        this._save();
    },

    get : function(name) {
        return this.settings[name];
    },

    getSettings : function() {
        return this.settings;
    },

    _save : function() {
        window.localStorage.setItem('settings', JSON.stringify(this.settings));
    }
};