(function(App, $) {

    var BroadcastPageView = Backbone.View.extend({

        template : App.templates['broadcast-page'],

        dataType : 'JSON',
        pageType : 'sub',
        pageClass : 'broadcast-page',
        pageTitle : 'Broadcast',

        events : {
            'tap .broadcast-refresh' : '_refresh'
        },

        _init : function() {
            this.render();
            this._initUI();
            this._resolve();
        },

        render : function() {
            this.page = this.template(_.extend({}, this.data, {
                id : this.id
            }));
        },

        _initUI : function() {
            this._initPlayer();
        },

        _initPlayer : function() {
            if (! this.data.streamIsActive) {
                return;
            }

            jwplayer('broadcast-player-' + this.id).setup({
                sources: [{
                    file: this.data.fileSmil
                },{
                    file: this.data.fileM3u8
                },{
                    file: this.data.fileF4m
                }],

                primary : 'flash',
                androidhls : true,

                aspectratio : '16:9',
                stretching : 'fill',
                width : "100%",

                /*ga : {
                    idstring: "${streamName}"
                },*/
                abouttext : 'About PrestoSports Live Streaming Player 1.0',
                aboutlink : 'http://www.prestosports.com/live_streaming/index',
                sharing : {
                    link : this.data.sharingURL
                },
                rtmp : {
                    bufferlength: '0.1'
                }
            });
        },

        _pageHide : function() {
            this._remove();
        }
    });

    Cocktail.mixin(BroadcastPageView, App.mixins.page);
    _.extend(App.views, { BroadcastPageView : BroadcastPageView });

})(App, jQuery);