(function(App, $) {

    var SettingsPageView = Backbone.View.extend({

        el : '#settings-page',

        events : {
            'change select' : '_selectChange'
        },

        _init : function() {
            this.$el.find('select').each(function() {
                var select = $(this);
                select.val(App.services.settings.get(this.name));
                if (select.hasClass('settings-slider')) {
                    select.slider('refresh');
                } else {
                    select.selectmenu().selectmenu('refresh');
                }
            });
            this._resolve();
        },

        _selectChange : function(e) {
            var select = $(e.currentTarget);

            App.services.settings.set(select.attr('name'), select.val());
        }
    });

    Cocktail.mixin(SettingsPageView, App.mixins.page);
    _.extend(App.views, { SettingsPageView : SettingsPageView });

})(App, jQuery);